/* MOL2 */
int rmol2(char *filename, int *atomnum, ATOM atom[], int *bondnum,
		  BOND bond[], CONTROLINFO *cinfo, MOLINFO *minfo, int flag)
{
/*if flag =1, read in atom type, if flag ==0, do not read in atom type */
	int i;
	int numatom;
	int numbond;
	int index = 0;
	int atomrecord = 0;
	int bondrecord = 0;
	int tmpint1;
	int tmpint2;
	int tmpint3;
	int tmpint4;
	int tmpint5;
	int mf1 = 1;
	int itype = 1;
	int overflow_flag = 0;
	double tmpf1, tmpf2, tmpf3, tmpf4;
	char type[MAXCHAR];
	char tmpchar1[MAXCHAR], tmpchar2[MAXCHAR], tmpchar3[MAXCHAR],
		tmpchar4[MAXCHAR], tmpchar5[MAXCHAR];
	char tmpc1[MAXCHAR];
	char line[MAXCHAR];
	FILE *fpin;

	if ((fpin = fopen(filename, "r")) == NULL) {
		fprintf(stderr, "Cannot open file %s, exit\n", filename);
		exit(0);
	}
	initial((*cinfo).maxatom, atom, (*minfo).resname);
	numatom = 0;
	numbond = 0;
	for (;;) {
		if (fgets(line, MAXCHAR, fpin) == NULL) break;

		sscanf(line, "%s%s%s", tmpchar1, tmpchar2, tmpchar3);
		if (strcmp("@<TRIPOS>MOLECULE", tmpchar1) == 0) {
			index = 1;
			continue;
		}
		if (strcmp("@<TRIPOS>ATOM", tmpchar1) == 0) {
			atomrecord = 1;
			continue;
		}
		if (strcmp("@<TRIPOS>BOND", tmpchar1) == 0) {
			bondrecord = 1;
			atomrecord = 0;
			continue;
		}
		if (strcmp("@<TRIPOS>SUBSTRUCTURE", tmpchar1) == 0) { /* end of bonds */
			bondrecord = 0;
			continue;
		}
		if (index == 1 && (*cinfo).rnindex != 1) {
			strcpy((*minfo).longresname, tmpchar1);
			index = -1;
		}

		/*  process the ATOM section:    */

		if (atomrecord) {
			sscanf(line, "%d%s%lf%lf%lf%s%d%s%lf", &tmpint1, tmpc1,
				   &tmpf1, &tmpf2, &tmpf3, tmpchar4,
				   &tmpint2, tmpchar5, &tmpf4);
			if( numatom==0 ) mf1 = tmpint1;  /* atom number of first atom */
			if (overflow_flag == 0) {
				if (strlen(tmpc1) > 4) {
					atom[numatom].name[0] = tmpc1[0];
					atom[numatom].name[1] = tmpc1[1];
					atom[numatom].name[2] = tmpc1[2];
					atom[numatom].name[3] = tmpc1[3];
					atom[numatom].name[4] = '\0';
				} else
					strcpy(atom[numatom].name, tmpc1);
				if (tmpc1[0] == '*') {
					for (i = 0; i < strlen(tmpchar4); i++) {
						if (tmpchar4[i] == '.')
							break;
						if (i > 3)
							break;
						atom[numatom].name[i] = tmpchar4[i];
					}
					atom[numatom].name[i] = '\0';
				}
				if (strlen(tmpc1) > 4) {
					atom[numatom].ambername[0] = tmpchar4[0];
					atom[numatom].ambername[1] = tmpchar4[1];
					atom[numatom].ambername[2] = tmpchar4[2];
					atom[numatom].ambername[3] = tmpchar4[3];
					atom[numatom].ambername[4] = '\0';
				} else
					strcpy(atom[numatom].ambername, tmpchar4);

				atom[numatom].x = tmpf1;
				atom[numatom].y = tmpf2;
				atom[numatom].z = tmpf3;
				atom[numatom].charge = tmpf4;
				if (flag == 1)
					if (strlen(tmpchar4) > 4) {
						atom[numatom].ambername[0] = tmpchar4[0];
						atom[numatom].ambername[1] = tmpchar4[1];
						atom[numatom].ambername[2] = tmpchar4[2];
						atom[numatom].ambername[3] = tmpchar4[3];
						atom[numatom].ambername[4] = '\0';
					} else
						strcpy(atom[numatom].ambername, tmpchar4);
				if ((*cinfo).rnindex == 1)
					strcpy(atom[numatom].aa, (*minfo).resname);
				else {
					if (strlen(tmpchar5) > 3) {
						atom[numatom].aa[0] = tmpchar5[0];
						atom[numatom].aa[1] = tmpchar5[1];
						atom[numatom].aa[2] = tmpchar5[2];
						atom[numatom].aa[3] = '\0';
					} else
						strcpy(atom[numatom].aa, tmpchar5);
				}
			}
			numatom++;
			if (numatom >= (*cinfo).maxatom && overflow_flag == 0) {
				printf
					("\nThe atom number exceeds the MAXATOM, reallocate memory");
				overflow_flag = 1;
			}
		}

		/*  process the BOND section:    */

		if (bondrecord) {
			sscanf(line, "%d%d%d%s", &tmpint3, &tmpint4, &tmpint5, type);
			if (overflow_flag == 0) {
				atom[tmpint4 - mf1].con[atom[tmpint4 - mf1].connum++] =
					tmpint5 - mf1;
				atom[tmpint5 - mf1].con[atom[tmpint5 - mf1].connum++] =
					tmpint4 - mf1;
				if (strcmp(type, "1") == 0)
					itype = 1;
				if (strcmp(type, "2") == 0)
					itype = 2;
				if (strcmp(type, "3") == 0)
					itype = 3;
				if (strcmp(type, "am") == 0)
					itype = 1;
				if (strcmp(type, "ar") == 0)
					itype = 10;
				if (strcmp(type, "SINGLE") == 0)
					itype = 1;
				if (strcmp(type, "DOUBLE") == 0)
					itype = 2;
				if (strcmp(type, "TRIPLE") == 0)
					itype = 3;
				bond[numbond].bondi = tmpint4 - mf1;
				bond[numbond].bondj = tmpint5 - mf1;
				bond[numbond].type = itype;
			}
			numbond++;
			if (numbond >= (*cinfo).maxbond && overflow_flag == 0) {
				printf
					("\nThe bond number exceeds the MAXBOND, reallocate memory");
				overflow_flag = 1;
			}
		}
	}
	fclose(fpin);
	*atomnum = numatom;
	*bondnum = numbond;
/*
	if(overflow_flag == 0) {
		tmpf1 = 0;
		tmpf2 = 0;
		for(i=0;i<numatom;i++) {
			if(atom[i].charge > 0)
				tmpf1+=atom[i].charge;
			else
				tmpf2+=atom[i].charge;
		}
		printf("\nchargep is %9.4lf", tmpf1);
		printf("\nchargen is %9.4lf", tmpf2);
	}
*/
	return overflow_flag;
}




void wmol2(char *filename, int atomnum, ATOM atom[], int bondnum,
		   BOND bond[], AROM arom[], CONTROLINFO cinfo, MOLINFO minfo)
{
	typedef struct {
        	char str[10];
	} ATOMNAME;
	
	int i, j, k, l;
	/* int breakindex; */
	int *bondat1;
	int *bondat2;
	int *bondtype;
	
	ATOMNAME *name;
	int *atomtype;
	char type[5];
	int tmpint;
	int index;
	FILE *fpout;
        bondat1 = (int *) malloc(sizeof(int) * (atomnum + 200));
        if (bondat1 == NULL) {
                fprintf(stderr, "memory allocation error for *bondat1 in wmol2()\n");
                exit(0);
        }
        bondat2 = (int *) malloc(sizeof(int) * (atomnum + 200));
        if (bondat2 == NULL) {
                fprintf(stderr, "memory allocation error for *bondat2 in wmol2()\n");
                exit(0);
        }
        bondtype = (int *) malloc(sizeof(int) * (atomnum + 200));
        if (bondtype == NULL) {
                fprintf(stderr, "memory allocation error for *bondtype in wmol2()\n");
                exit(0);
        }
        atomtype = (int *) malloc(sizeof(int) * (atomnum + 10));
        if (atomtype == NULL) {
                fprintf(stderr, "memory allocation error for *atomtype in wmol2()\n");
                exit(0);
        }
        name = (ATOMNAME *) malloc(sizeof(ATOMNAME) * (atomnum +10));
        if (name == NULL) {
                fprintf(stderr, "memory allocation error for *name in wmol2()\n");
                exit(0);
        }

	if ((fpout = fopen(filename, "w")) == NULL) {
		fprintf(stderr, "Cannot open file %s, exit\n", filename);
		return;
	}
	for (i = 0; i < atomnum; i++)
		atomtype[i] = -1;
	/*
	   1: triple bond atom
	   2: double bond atom
	   3,4: single bond atom
	   5: amide N
	   6: aromatic atom
	 */
	for (i = 0; i < atomnum + 200; i++) {
		bondat1[i] = -1;
		bondat2[i] = -1;
		bondtype[i] = -1;
		/*
		   1: single bond
		   2: double bond
		   3: triple bond
		   4: amide
		   5: aromatic
		 */
	}
	for (i = 0; i < atomnum; i++) {
		switch (atom[i].atomicnum) {
		case 6:
			if (atom[i].connum == 4) {
				strcpy(name[i].str, "C.3");
				atomtype[i] = 3;
			}
			if (atom[i].connum == 2) {
				strcpy(name[i].str, "C.1");
				atomtype[i] = 1;
			}
			if (atom[i].connum == 3)
				if (arom[i].ar1 > 0) {
					strcpy(name[i].str, "C.ar");
					atomtype[i] = 6;
				} else {
					strcpy(name[i].str, "C.2");
					atomtype[i] = 2;
				}
			break;
		case 7:
			if (atom[i].connum == 1) {
				strcpy(name[i].str, "N.1");
				atomtype[i] = 1;
			}
			if (atom[i].connum == 2) {
				strcpy(name[i].str, "N.2");
				atomtype[i] = 2;
			}
			if (atom[i].connum == 4) {
				strcpy(name[i].str, "N.4");
				atomtype[i] = 4;
			}
			if (atom[i].connum == 3) {
				strcpy(name[i].str, "N.3");
				atomtype[i] = 3;
				index = 0;
				for (j = 0; j < 6; j++) {
					tmpint = atom[i].con[j];
					if (tmpint < 0)
						continue;
					if (atom[tmpint].saturate == -1)
						index++;
				}
				if (index >= 2) {
					strcpy(name[i].str, "N.pl3");
					atomtype[i] = 3;
				}
				index = 0;
				for (j = 0; j < 6; j++) {
					tmpint = atom[i].con[j];
					if (tmpint < 0)
						continue;
					for (k = 0; k < 6; k++) {
						if (atom[tmpint].con[k] < 0)
							continue;
						if (atom[atom[tmpint].con[k]].atomicnum == 8 &&
							atom[atom[tmpint].con[k]].connum == 1) {
							index = 1;
							break;
						}
					}
					if (index == 1)
						break;
				}
				if (index == 1) {
					strcpy(name[i].str, "N.am");
					atomtype[i] = 5;
				}
			}
			if (arom[i].ar1 > 0)
				strcpy(name[i].str, "N.ar");
			break;
		case 8:
			if (atom[i].connum == 2 || atom[i].connum == 3) {
				strcpy(name[i].str, "O.3");
				atomtype[i] = 3;
			}
			if (atom[i].connum == 1) {
				{
					strcpy(name[i].str, "O.2");
					atomtype[i] = 2;
				}
				if (atom[i].connum == 1)
					for (j = 0; j < 6; j++) {
						if (atom[i].con[j] < 0)
							continue;
						if (atom[atom[i].con[j]].atomicnum == 15) {
							strcpy(name[i].str, "O.3");
							atomtype[i] = 3;
							break;
						}
					}
			}
			break;
		case 15:
			strcpy(name[i].str, "P.3");
			atomtype[i] = 3;
			break;
		case 16:

			if (atom[i].connum == 1) {
				strcpy(name[i].str, "S.2");
				atomtype[i] = 2;
			} else {
				strcpy(name[i].str, "S.3");
				atomtype[i] = 3;
			}
			tmpint = 0;
			for (j = 0; j < 6; j++) {
				if (atom[i].con[j] < 0)
					continue;
				if (atom[atom[i].con[j]].atomicnum == 8 &&
					atom[atom[i].con[j]].connum == 1)
					tmpint++;
			}
			if (tmpint == 1) {
				strcpy(name[i].str, "S.o");
				atomtype[i] = 2;
			}
			if (tmpint == 2) {
				strcpy(name[i].str, "S.o2");
				atomtype[i] = 2;
			}
			break;
		case 1:
			strcpy(name[i].str, "H");
			atomtype[i] = 3;
			break;
		case 9:
			strcpy(name[i].str, "F");
			atomtype[i] = 3;
			break;
		case 17:
			strcpy(name[i].str, "Cl");
			atomtype[i] = 3;
			break;
		case 35:
			strcpy(name[i].str, "Br");
			atomtype[i] = 3;
			break;
		case 53:
			strcpy(name[i].str, "I");
			atomtype[i] = 3;
			break;
		default:
			strcpy(name[i].str, "du");
			atomtype[i] = 3;
		}
	}
	tmpint = 0;
	index = 0;

	/*
	   breakindex = 0;
	 */

	for (i = 0; i < atomnum; i++)
		for (j = i + 1; j < atomnum; j++)
			for (k = 0; k < bondnum; k++)
				if ((bond[k].bondi == i && bond[k].bondj == j) ||
					(bond[k].bondi == j && bond[k].bondj == i)) {
					bondat1[tmpint] = i;
					bondat2[tmpint] = j;
					bondtype[tmpint] = bond[k].type;
					tmpint++;
					/* deal with amide bond */
					if (atomtype[i] == 5) {
						if (atom[j].connum == 3 && atom[j].atomicnum == 6)
							for (l = 0; l < 3; l++) {
								if (atom[j].con[l] < 0)
									continue;
								if (atom[atom[j].con[l]].atomicnum == 8 &&
									atom[atom[j].con[l]].connum == 1) {
									index = 1;
									break;
								}
							}
						if (index == 1) {
							index = 0;
							bondtype[tmpint - 1] = 4;
							break;
						}
					}
					if (atomtype[j] == 5) {
						if (atom[i].connum == 3 && atom[i].atomicnum == 6)
							for (l = 0; l < 3; l++) {
								if (atom[i].con[l] < 0)
									continue;
								if (atom[atom[i].con[l]].atomicnum == 8 &&
									atom[atom[i].con[l]].connum == 1) {
									index = 1;
									break;
								}
							}
						if (index == 1) {
							index = 0;
							bondtype[tmpint - 1] = 4;
							break;
						}
					}
				}
	fprintf(fpout, "@<TRIPOS>MOLECULE\n");
	if (strlen(minfo.longresname) <= 1)
		strcpy(minfo.longresname, atom[0].aa);
	fprintf(fpout, "%s\n", minfo.longresname);
	fprintf(fpout, "%5d%6d%6d%6d%6d\n", atomnum, tmpint, 1, 0, 0);
	fprintf(fpout, "SMALL\n");
	if(strlen(cinfo.chargetype)<=1) strcpy(cinfo.chargetype, "No Charge or Current Charge"); 
	fprintf(fpout, "%s\n\n\n", cinfo.chargetype);
	fprintf(fpout, "@<TRIPOS>ATOM\n");
	for (i = 0; i < atomnum; i++) {
		if (strcmp(minfo.atom_type_def, "sybyl") == 0
			|| strcmp(minfo.atom_type_def, "SYBYL") == 0) {
			/* use sybyl types */
			fprintf(fpout,
					"%7d %-8s%10.4lf%10.4lf%10.4lf %-6s%5d %-8s%8.4lf\n",
					i + 1, atom[i].name, atom[i].x, atom[i].y, atom[i].z,
					name[i].str, atom[i].resno, atom[i].aa, atom[i].charge);
		} else {				/* use ambername */
			fprintf(fpout,
					"%7d %-8s%10.4lf%10.4lf%10.4lf %-6s%5d %-8s%8.4lf\n",
					i + 1, atom[i].name, atom[i].x, atom[i].y, atom[i].z,
					atom[i].ambername, atom[i].resno, atom[i].aa,
					atom[i].charge);
		}
	}
	fprintf(fpout, "@<TRIPOS>BOND\n");
	for (i = 0; i < tmpint; i++)
		for (j = i + 1; j < tmpint; j++)
			if (bondtype[i] == bondtype[j] && bondtype[i] == 9) {
				if (bondat1[i] == bondat1[j] || bondat1[i] == bondat2[j])
					if (atom[bondat1[i]].atomicnum == 6
						&& atom[bondat1[i]].connum == 4) {
						bondtype[i] = -18;
						bondtype[j] = -18;
					} else {
						bondtype[i] = -9;
						bondtype[j] = -9;
					}
				if (bondat2[i] == bondat1[j] || bondat2[i] == bondat2[j])
					bondtype[j] = -9;
				if (atom[bondat2[i]].atomicnum == 6
					&& atom[bondat2[i]].connum == 4) {
					bondtype[i] = -18;
					bondtype[j] = -18;
				} else {
					bondtype[i] = -9;
					bondtype[j] = -9;
				}
			}
	for (i = 0; i < tmpint; i++) {
		fprintf(fpout, "%6d%5d%5d", i + 1, bondat1[i] + 1, bondat2[i] + 1);
		if (bondtype[i] == 1)
			strcpy(type, "1");
		else if (bondtype[i] == 2)
			strcpy(type, "2");
		else if (bondtype[i] == 3)
			strcpy(type, "3");
		else if (bondtype[i] == 4)
			strcpy(type, "am");
		else if (bondtype[i] == 9)
			strcpy(type, "1");
		else if (bondtype[i] == -9)
			strcpy(type, "2");
		else if (bondtype[i] == -18)
			strcpy(type, "1");
		else if (bondtype[i] == 10)
			strcpy(type, "ar");
  		else if (bondtype[i] == 7) {
                        if(arom[bondat1[i]].ar1 >=1 && arom[bondat2[i]].ar1 >=1)
				strcpy(type, "ar");
			else
				strcpy(type, "1");
		}
  		else if (bondtype[i] == 8) {
			if(arom[bondat1[i]].ar1 ==1 && arom[bondat2[i]].ar1 >=1)
				strcpy(type, "ar");
			else
				strcpy(type, "2");
		}
		else
			strcpy(type, "1");
		fprintf(fpout, " %-4s\n", type);
	}
	fprintf(fpout, "@<TRIPOS>SUBSTRUCTURE\n");
	fprintf(fpout, "%s%-12s%s", "     1 ", atom[0].aa,
			"1 TEMP              0 ****  ****    0 ROOT\n");
	free(bondat1);
	free(bondat2);
	free(bondtype);
	free(atomtype);
	free(name);
	fclose(fpout);
}
